from enum import Enum


class PruningStage(Enum):
    Pretrain = 'pretrian'
    Prune = 'prune'
    Retrain = 'retrain'


class PruningType(Enum):
    Structured = 'structured'
    Unstructured = 'unstructured'


class PruningEngine(Enum):
    PyTorch = 'PyTorch'
    NumPy = 'NumPy'


class PruningMethod(Enum):
    Filter = 'filter'
    Channel = 'channel'
    Unstructured = 'unstructured'
    Bcr = 'bcr'


class PruningCriterion(Enum):
    L1 = 'l1'
    L2 = 'l2'
    Unstructured = 'unstructured'


def str2enums_id(s):
    enums_id = None
    if s == 'pretrain':
        enums_id = PruningStage.Pretrain
    elif s == 'prune':
        enums_id = PruningStage.Prune
    elif s == 'retrain':
        enums_id = PruningStage.Retrain
    elif s == 'numpy':
        enums_id = PruningEngine.NumPy
    elif s == 'pytorch':
        enums_id = PruningEngine.PyTorch
    elif s == 'filter':
        enums_id = PruningMethod.Filter
    elif s == 'channel':
        enums_id = PruningMethod.Channel
    elif s == 'unstructured':
        enums_id = PruningMethod.Unstructured
    elif s == 'bcr':
        enums_id = PruningMethod.Bcr

    elif s == 'l1':
        enums_id = PruningCriterion.L1
    elif s == 'l2':
        enums_id = PruningCriterion.L2
    elif s == 'unstructured':
        enums_id = PruningCriterion.Unstructured
    return enums_id
